
#ifndef __D3D8VERTEXBUFFER_H_
#define __D3D8VERTEXBUFFER_H_
/**************************************************************************************
* This file is part of the GameFramework project released by Wazoo Enterprises Inc.
* under the GNU Public License. 
*
* Any projects using this code must attach these copyright notices along with their
* own as outlined at http://www.gnu.org
*
* Copyright 2003 by Wazoo Enterprises Inc.
* To contact the auther, send a message to wazoo@wazooenterprises.com
*
****************************************************************************************/


#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>

#include "..\vbInterface.h"


struct CUSTOM_VERTEX {

	D3DXVECTOR3 vecPos;
	DWORD		dwColor;
};

#define D3DFVF_CUSTOM_VERTEX ( D3DFVF_XYZ | D3DFVF_DIFFUSE )


class D3DVertexBuffer : public vbInterface {

protected:

	UINT m_iVertexSize;
	UINT m_iVertexLimit; //max number of vertices to batch
	UINT  m_iVerticesInBuffer;
	BOOL m_bIsLocked;    //is our VB locked?
	CUSTOM_VERTEX *m_pVertices;
	LPDIRECT3DVERTEXBUFFER8 m_lpVB;

	LPDIRECT3DDEVICE8 m_lpD3DDevice;



public:
	D3DVertexBuffer();
	~D3DVertexBuffer();

	HRESULT createVB(int, VOID*);
	void destroyVB();

	HRESULT lockVB();
	void unlockVB();

	void addTriToVB(D3DXVECTOR3 pos,
		FLOAT r, FLOAT g, FLOAT b, FLOAT a);

    void flushVB();


};

#endif